package edu.sdsc.sirius.monitors;

import javax.swing.*;
import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import edu.sdsc.mbt.*;
import edu.sdsc.sirius.util.Manager;

public class MonitorDialog extends JDialog {
	
	private MonitorPanel monitorPanel;
	private Manager callable;
	private JFrame parent;
	
	private int width = 260;
	private int height = 450;
	
	public MonitorDialog(JFrame p, Manager c){
		super(p, "Interactions et contrles", false);
		
		this.callable = c;
		this.parent = p;
		
		monitorPanel = new MonitorPanel(callable);
		getContentPane().add(monitorPanel, BorderLayout.CENTER);
		
		WindowAdapter closer = new WindowAdapter(){
			public void windowClosing( WindowEvent event ){

				setVisible(false);
				callable.closeMonitorDialog();
			}
		};
		addWindowListener( closer );
		
		//position the window
		Dimension dim = getToolkit().getScreenSize();
		
		//position the panel next to the main window on the right
		//if it ends up being wider than screen, fit it to the width of the screen
		if ((parent.getX() + parent.getWidth() + width) > dim.getWidth()){
			setBounds(dim.width - width, parent.getY(), width, height);
		}
		else{
			setBounds(parent.getX() + parent.getWidth(), parent.getY(), width, height);
		}
		
		
		
		
		
		setSize(width, height);
//		setResizable(false);

		setVisible(true);

	}
	
	public void setSelection(AnnotationComponent ac, boolean selected){
		monitorPanel.setSelection(ac, selected);
	}
	
	public void setVisibility(AnnotationComponent ac, boolean visible, boolean batch){
		monitorPanel.setVisibility(ac, visible, batch);
	}
	
	public void clearSelection(){
		monitorPanel.clearSelection();
	}
	
	public void updateTree(){
		monitorPanel.updateTree();
	}
	
	public void repaintTree(){
		monitorPanel.repaint();
	}
	
	
	
}
