package edu.sdsc.sirius.monitors;

import javax.swing.*;

import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.border.*;
import edu.sdsc.mbt.util.*;

import edu.sdsc.mbt.*;

import edu.sdsc.mbt.viewers.GLViewerImpl.*;
import edu.sdsc.sirius.dialogs.*;
import edu.sdsc.sirius.util.FileNameFilter;
import edu.sdsc.sirius.util.Manager;
import edu.sdsc.sirius.util.StringUtils;
import edu.sdsc.sirius.viewers.*;

public class MonitorPanel extends JPanel {
	
	private Manager callable;
	private StructureViewer structureViewer;
	
	private HashMap monitors;
	private HashMap hbonds;
	private HashMap bumps;
	private HashMap labels;
	
	private JTree tree;
	private DefaultTreeModel model;
	
	private Vector selectedNodes = new Vector();
	private HashMap nodeMap = new HashMap();//DefaultMutableTreeNode -> MonitorNode
	
	private Object[] nodes;
	
	private JScrollPane sp = new JScrollPane();
	
	private JPanel panel = new JPanel();
	private JButton buttonShow = new JButton("Afficher");
	private JButton buttonHide = new JButton("Masquer");
	private JButton buttonDelete = new JButton("Supprimer");

	private MonitorNodeSelectionListener listener = new MonitorNodeSelectionListener();
	
	private final ImageIcon nodeVisible = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/tree_visible.gif"));
	private final ImageIcon nodeInvisible = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/tree_invisible.gif"));
	
	private final ImageIcon PARENT_OPEN = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/parent_open.gif"));
	private final ImageIcon PARENT_CLOSED = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/parent_closed.gif"));
	
	private final ImageIcon DISTANCE_OPEN = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/distance_open.gif"));
	private final ImageIcon DISTANCE_CLOSED = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/distance_closed.gif"));
	
	private final ImageIcon HB_OPEN = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/hb_open.gif"));
	private final ImageIcon HB_CLOSED = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/hb_closed.gif"));
		
	private final ImageIcon BUMPS_OPEN = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/bumps_open.gif"));
	private final ImageIcon BUMPS_CLOSED = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/bumps_closed.gif"));

	private final ImageIcon LABELS_OPEN = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/labels_open.gif"));
	private final ImageIcon LABELS_CLOSED = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/labels_closed.gif"));

	private final ImageIcon DISTANCE_VISIBLE = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/distance_visible.gif"));
	private final ImageIcon DISTANCE_INVISIBLE = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/distance_invisible.gif"));
	
	private final ImageIcon HB_VISIBLE = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/hb_visible.gif"));
	private final ImageIcon HB_INVISIBLE = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/hb_invisible.gif"));
		
	private final ImageIcon BUMPS_VISIBLE = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/bumps_visible.gif"));
	private final ImageIcon BUMPS_INVISIBLE = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/bumps_invisible.gif"));

	private final ImageIcon LABELS_VISIBLE = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/label_visible.gif"));
	private final ImageIcon LABELS_INVISIBLE = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/monitors/label_invisible.gif"));
	
	private JMenuBar menuBar;
	
	
	private DefaultMutableTreeNode distanceNode;//parent nodes
	private DefaultMutableTreeNode hbNode;
	private DefaultMutableTreeNode bumpNode;
	private DefaultMutableTreeNode labelNode;
	
	private DefaultMutableTreeNode rootNode;
	
	private boolean[] expanded = new boolean[4];

	public MonitorPanel(Manager callable){
		
		this.callable = callable;
		this.structureViewer = callable.getStructureViewer();
		
		monitors = structureViewer.getMonitors();
		hbonds = structureViewer.getHBonds();
		bumps = structureViewer.getBumps();
		labels = structureViewer.getLabels();
				
		setLayout(new BorderLayout());
		
		menuBar = createMenuBar();
		
		add(menuBar, BorderLayout.NORTH);
		
		createTree();
		
				
		sp.getViewport().add(tree);
		
		tree.setBorder(new EmptyBorder(5,5,5,5));
//		tree.setBackground(new Color(0.9f, 0.9f, 0.9f));
		
		add(sp, BorderLayout.CENTER);
		
		panel.setPreferredSize(new Dimension(250,45));
		panel.setLayout(null);
		
		buttonShow.setBounds(10, 10, 70, 25);
		buttonShow.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				showSelected();
			}
		});
		
		buttonHide.setBounds(90, 10, 70, 25);
		buttonHide.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				hideSelected();
			}
		});

		buttonDelete.setBounds(170, 10, 70, 25);
		buttonDelete.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				deleteSelectedNodes();
			}
		});
		
		panel.add(buttonShow);
		panel.add(buttonHide);
		panel.add(buttonDelete);
		
		add(panel, BorderLayout.SOUTH);
		
		
		
		setVisible(true);
	}
	
	public void showSelected(){
		
		Object[] paths = tree.getSelectionPaths();//shows what's currently selected
		if (paths == null){
			//nothing selected
			return;
		}
		
		Vector selectedNodes = new Vector();
		for (int i = 0; i < paths.length; i++){
			Object[] elements = ((TreePath)paths[i]).getPath();
			String n = "";
			
			MonitorNode currentNode = null;
			for (int j = 0; j < elements.length; j++){
				DefaultMutableTreeNode t = (DefaultMutableTreeNode)elements[j];
				currentNode = (MonitorNode)t.getUserObject();
			}
			
			selectedNodes.add(currentNode);
		}
		
		for (int i = 0; i < selectedNodes.size(); i++){
			MonitorNode node = (MonitorNode)selectedNodes.get(i);
			AnnotationComponent component = (AnnotationComponent)node.getAnnotationComponent();
			if (component == null) continue;
			
			structureViewer.setAnnotationVisibility(component, true, true);
		}
		repaint();
		callable.updateView();
	}
	
	public void hideSelected(){
		
		Object[] paths = tree.getSelectionPaths();//shows what's currently selected
		if (paths == null){
			//nothing selected
			return;
		}
		
		Vector selectedNodes = new Vector();
		for (int i = 0; i < paths.length; i++){
			Object[] elements = ((TreePath)paths[i]).getPath();
			String n = "";
			
			MonitorNode currentNode = null;
			for (int j = 0; j < elements.length; j++){
				DefaultMutableTreeNode t = (DefaultMutableTreeNode)elements[j];
				currentNode = (MonitorNode)t.getUserObject();
			}
			
			selectedNodes.add(currentNode);
		}
		
		for (int i = 0; i < selectedNodes.size(); i++){
			MonitorNode node = (MonitorNode)selectedNodes.get(i);
			AnnotationComponent component = (AnnotationComponent)node.getAnnotationComponent();
			if (component == null) continue;
			
			structureViewer.setAnnotationVisibility(component, false, true);
		}
		
		repaint();
		callable.updateView();
	}
	
	public void setVisibility(AnnotationComponent ac, boolean visible, boolean batch){
		
		if (ac == null) return;
		ac.setVisible(visible);
		
		if (!batch){
			revalidate();
			repaint();
		}
	}

	
	private void deleteSelectedNodes(){
		//get current selection
		
		Object[] paths = tree.getSelectionPaths();//shows what's currently selected
		if (paths == null){
			//nothing selected
			return;
		}
		
		Vector selectedNodes = new Vector();
		for (int i = 0; i < paths.length; i++){
			Object[] elements = ((TreePath)paths[i]).getPath();
			String n = "";
			
			MonitorNode currentNode = null;
			for (int j = 0; j < elements.length; j++){
				DefaultMutableTreeNode t = (DefaultMutableTreeNode)elements[j];
				currentNode = (MonitorNode)t.getUserObject();
			}
			
			selectedNodes.add(currentNode);
		}
		
		for (int i = 0; i < selectedNodes.size(); i++){
			MonitorNode node = (MonitorNode)selectedNodes.get(i);
			
			/**
			 * TODO if a parent node is selected, delete the entire class of monitors
			 */
			AnnotationComponent component = (AnnotationComponent)node.getAnnotationComponent();
			if (component == null) continue;

			structureViewer.removeAnnotationComponent(component, false);
		}
		
		Thread runner = new Thread(){
			public void run(){
				callable.updateView();
				callable.updateMonitorDialog();
			}
		};
		
		runner.start();
	}
	
	
	public void updateTree(){
		
		//record which subtrees are collapsed and which are expanded, to restore the state
		//with a minimum of change
		
		if (distanceNode != null){
			TreePath p0 = new TreePath(distanceNode.getPath());
			expanded[0] = tree.isExpanded(p0);
		}
		
		if (hbNode != null){
			TreePath p1 = new TreePath(hbNode.getPath());
			expanded[1] = tree.isExpanded(p1);
		}
		
		if (bumpNode != null){
			TreePath p2 = new TreePath(bumpNode.getPath());
			expanded[2] = tree.isExpanded(p2);
		}
		
		if (labelNode != null){
			TreePath p2 = new TreePath(labelNode.getPath());
			expanded[3] = tree.isExpanded(p2);
		}
		
		//this method is called by structure viewer when new monitors are added/removed
		sp.getViewport().remove(tree);
		tree.removeTreeSelectionListener(listener);
		
		createTree();
		
		if (expanded[0]){
			TreePath tp = new TreePath(distanceNode.getPath());
			tree.expandPath(tp);
		}
		
		if (expanded[1]){
			TreePath tp = new TreePath(hbNode.getPath());
			tree.expandPath(tp);
		}
		
		if (expanded[2]){
			TreePath tp = new TreePath(bumpNode.getPath());
			tree.expandPath(tp);
		}
		
		if (expanded[3]){
			TreePath tp = new TreePath(labelNode.getPath());
			tree.expandPath(tp);
		}
		
		sp.getViewport().add(tree);
		
		tree.setBorder(new EmptyBorder(5,5,5,5));
		
		add(sp, BorderLayout.CENTER);
		
		revalidate();
		repaint();
	}
	
	private void createTree(){
		//create the tree structure
		nodeMap.clear();

		int length = monitors.size() + hbonds.size() + bumps.size() + labels.size() + 1;
		if (monitors.size() > 0) length++;
		if (hbonds.size() > 0) length++;
		if (bumps.size() > 0) length++;
		if (labels.size() > 0) length++;
		
		nodes = new Object[length];
		
//		System.out.println("initial nodes length = " + nodes.length);
		
		int counter = 0;
		
		DefaultMutableTreeNode top = new DefaultMutableTreeNode(new MonitorNode(0, "Display markers", null, true));
		DefaultMutableTreeNode parent = top;
		nodes[counter++] = top;
		rootNode = top;
		
		DefaultMutableTreeNode node = null;

		//next, add distance root
		if (monitors.size() >0){
			DefaultMutableTreeNode distances = new DefaultMutableTreeNode(new MonitorNode(0, "Marqueurs de distance", null, true));
			top.add(distances);
			nodes[counter++] = distances;
			distanceNode = distances;
			parent = distances;
			
			//go over all distance markers
			int idCounter = 0;
			Set keys = monitors.keySet();
			Iterator it = keys.iterator();
			while (it.hasNext()){
				MonitorComponent comp = (MonitorComponent)it.next();
//				System.out.println("dist = " + comp);
				String label = comp.label;
				String a1 = comp.atom1.residue.getCompoundCode()+comp.atom1.residue.getResidueId() + ":" + comp.atom1.name;
				String a2 = comp.atom1.residue.getCompoundCode()+comp.atom1.residue.getResidueId() + ":" + comp.atom2.name;
				String tag = a1 + " - " + a2 + ": " + label;
//				System.out.println("tag = " + tag);
				node = new DefaultMutableTreeNode(new MonitorNode(idCounter, tag, comp, false));
				parent.add(node);
				nodes[counter++] = node;
				
				nodeMap.put(comp, node);
				idCounter++;
			}
		}
		
		//add hydrogen bond root
		if (hbonds.size() > 0){
			DefaultMutableTreeNode hbondsParent = new DefaultMutableTreeNode(new MonitorNode(0, "Liaisons hydrogne", null, true));
			top.add(hbondsParent);
			nodes[counter++] = hbondsParent;
			hbNode = hbondsParent;
			parent = hbondsParent;
			
			//go over all hydrogen bond markers
			int idCounter = 0;
			Set keys = hbonds.keySet();
			Iterator it = keys.iterator();
			while (it.hasNext()){
				HydrogenBondComponent comp = (HydrogenBondComponent)it.next();
//				System.out.println("hbond = " + comp);
				String label = comp.label;
				String a1 = comp.atom1.residue.getCompoundCode() + comp.atom1.residue.getResidueId() + ":" + comp.atom1.name;
				String a2 = comp.atom2.residue.getCompoundCode() + comp.atom2.residue.getResidueId() + ":" + comp.atom2.name;
				String tag = a1 + " - " + a2;
//				System.out.println("tag = " + tag);
				node = new DefaultMutableTreeNode(new MonitorNode(idCounter, tag, comp, false));
				parent.add(node);
				nodes[counter++] = node;
				nodeMap.put(comp, node);
				idCounter++;
			}
		}
		
		//add bumps root
		if (bumps.size() > 0){
			DefaultMutableTreeNode bumpsParent = new DefaultMutableTreeNode(new MonitorNode(0, "Marqueurs de choc strique", null, true));
			top.add(bumpsParent);
			nodes[counter++] = bumpsParent;
			bumpNode = bumpsParent;
			parent = bumpsParent;
			
			int idCounter = 0;
			//go over all hydrogen bond markers
			Set keys = bumps.keySet();
			Iterator it = keys.iterator();
			while (it.hasNext()){
				StericBumpComponent comp = (StericBumpComponent)it.next();
//				System.out.println("bump = " + comp);
				String label = comp.label;
				String a1 = comp.atom1.residue.getCompoundCode()+comp.atom1.residue.getResidueId() + ":" + comp.atom1.name;
				String a2 = comp.atom2.residue.getCompoundCode()+comp.atom2.residue.getResidueId() + ":" + comp.atom2.name;
				String tag = a1 + " - " + a2;
//				System.out.println("tag = " + tag);
				node = new DefaultMutableTreeNode(new MonitorNode(idCounter, tag, comp, false));
				parent.add(node);
				nodeMap.put(comp, node);
				nodes[counter++] = node;
				idCounter++;
			}
		}
			
		//add labels root
		if (labels.size() > 0){
			DefaultMutableTreeNode labelsParent = new DefaultMutableTreeNode(new MonitorNode(0, "Etiquettes", null, true));
			top.add(labelsParent);
			nodes[counter++] = labelsParent;
			labelNode = labelsParent;
			parent = labelsParent;
			
			int idCounter = 0;
			//go over all hydrogen bond markers
			Set keys = labels.keySet();
			Iterator it = keys.iterator();
			while (it.hasNext()){
				String tag = null;
				Object component = it.next();
				try{
					LabelComponent comp = (LabelComponent)component;
					String label = comp.getText();
					String a = comp.atom.name;
					tag = a + ": " + label;
					node = new DefaultMutableTreeNode(new MonitorNode(idCounter, tag, comp, false));
					nodeMap.put(comp, node);
				}
				catch (ClassCastException e){
					ResidueLabelComponent comp = (ResidueLabelComponent)component;
					String label = comp.getText();
					tag = "Rsidu :" + comp.getText();
					node = new DefaultMutableTreeNode(new MonitorNode(idCounter, tag, comp, false));
					nodeMap.put(comp, node);
				}
				parent.add(node);
				nodes[counter++] = node;
				idCounter++;
			}
		}
		model = new DefaultTreeModel(top);
		tree = new JTree(model);
		
		/**
		 * TODO for now, don't use custom renderers on Mac - they get repainted incorrectly
		 */
		String os = System.getProperty("os.name");
		DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
		TreeCellRenderer customRenderer = new IconCellRenderer();
		
		if (os.startsWith("Mac")){
			tree.setCellRenderer(renderer);
		}
		else{
			tree.setCellRenderer(customRenderer);
		}
		
		tree.setEditable(false);
		
		tree.setSelectionPath(null);

		tree.addTreeSelectionListener(listener);
		
		tree.addMouseListener(new MouseInputAdapter(){
			public void mouseClicked(MouseEvent e){
				TreePath path = tree.getPathForLocation(e.getX(), e.getY());
				if (path == null){
					clearSelection();
					callable.updateView();
				}
				
			}
		});
//		tree.setBackground(new Color(0.9f, 0.9f, 0.9f));

	}
	
	public void clearSelection(){
//		System.out.println("Clearing selection");
		
		for (int i = 0; i < selectedNodes.size(); i++){
			MonitorNode m = (MonitorNode)selectedNodes.get(i);

			try{
				AnnotationComponent ac = m.getAnnotationComponent();
				if (ac == null) continue;
				
				ac.setSelected(false);
				m.selected = false;
			
			}
			catch (Exception ex){
///				System.out.println("e = " + ex);
			}

		}
		
		structureViewer.clearAnnotationSelection();
		tree.getSelectionModel().setSelectionPaths(null);
		revalidate();
		repaint();
		
	}
	
	public void setSelection(AnnotationComponent ac, boolean selection){
		
		DefaultMutableTreeNode node = (DefaultMutableTreeNode)nodeMap.get(ac);
		if (node == null) return;
		
		MonitorNode n = (MonitorNode)node.getUserObject();

		//find path to this node
		TreeNode[] pathNodes = node.getPath();

		tree.addSelectionPath(new TreePath(pathNodes));
		
		revalidate();
		repaint();
		
		
	}
	
	class MonitorNode {
		
		protected int m_id;
		protected String m_name;
		protected AnnotationComponent component;
		
		protected Icon nodeIconVisible = nodeVisible;
		protected Icon nodeIconInvisible = nodeInvisible;
		
		private boolean parentNode = false;
		
		
		
		public boolean selected = false;
		
		public MonitorNode(int id, String name, AnnotationComponent component, boolean parent){
			m_id = id;
			m_name = name;
			this.component = component;
			this.parentNode = parent;
		}
		
		public int getId(){
			return m_id;
		}
		
		public String getName(){
			return m_name;
		}
		
		public String toString(){
			return m_name;
		}
		
		public AnnotationComponent getAnnotationComponent(){
			return component;
		}
		
		public Icon getExpandedIcon(){
			if (parentNode){
				if (this == rootNode.getUserObject()){
					//check whether it's collapsed or not
					return PARENT_OPEN;
				}
				else if (distanceNode != null && this == distanceNode.getUserObject()){
					return DISTANCE_OPEN;
				}
				else if (hbNode != null && this == hbNode.getUserObject()){
					return HB_OPEN;
				}
				else if (bumpNode != null && this == bumpNode.getUserObject()){
					return BUMPS_OPEN;
				}
				else if (labelNode != null && this == labelNode.getUserObject()){
					return LABELS_OPEN;
				}

				
				return PARENT_OPEN;
			}
			
			if (component.getVisible()){
				return nodeVisible;
			}
			else{
				return nodeInvisible;
			}
		}
		
		public Icon getIcon(){
			if (parentNode){
				if (this == rootNode.getUserObject()){
					//check whether it's collapsed or not
					TreePath p0 = new TreePath(rootNode.getPath());
					if (tree.isExpanded(p0)){
						return PARENT_OPEN;
					}
					else{
						return PARENT_CLOSED;
					}
				}
				else if (distanceNode != null && this == distanceNode.getUserObject()){
					TreePath p0 = new TreePath(distanceNode.getPath());
					if (tree.isExpanded(p0)){
						return DISTANCE_OPEN;
					}
					else{
						return DISTANCE_CLOSED;
					}
				}
				else if (hbNode != null && this == hbNode.getUserObject()){
					TreePath p0 = new TreePath(hbNode.getPath());
					if (tree.isExpanded(p0)){
						return HB_OPEN;
					}
					else{
						return HB_CLOSED;
					}
				}
				else if (bumpNode != null && this == bumpNode.getUserObject()){
					TreePath p0 = new TreePath(bumpNode.getPath());
					if (tree.isExpanded(p0)){
						return BUMPS_OPEN;
					}
					else{
						return BUMPS_CLOSED;
					}
				}
				else if (labelNode != null && this == labelNode.getUserObject()){
					TreePath p0 = new TreePath(labelNode.getPath());
					if (tree.isExpanded(p0)){
						return LABELS_OPEN;
					}
					else{
						return LABELS_CLOSED;
					}
				}

				
				return PARENT_OPEN;
			}
			
			if (component.getVisible()){
				if (component.getType() == AnnotationComponentRegistry.TYPE_MONITOR){
					return DISTANCE_VISIBLE;
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_HYDROGEN_BOND){
					return HB_VISIBLE;
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_STERIC_BUMP){
					return BUMPS_VISIBLE;
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_LABEL){
					return LABELS_VISIBLE;
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_RESIDUE_LABEL){
					return LABELS_VISIBLE;
				}
				else{
					//default
					return HB_VISIBLE;
				}
			}
			else{
				if (component.getType() == AnnotationComponentRegistry.TYPE_MONITOR){
					return DISTANCE_INVISIBLE;
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_HYDROGEN_BOND){
					return HB_INVISIBLE;
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_STERIC_BUMP){
					return BUMPS_INVISIBLE;
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_LABEL){
					return LABELS_INVISIBLE;
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_RESIDUE_LABEL){
					return LABELS_INVISIBLE;
				}
				else{
					//default
					return HB_INVISIBLE;
				}
			}
		}
	}
	
	class MonitorNodeSelectionListener implements TreeSelectionListener {
		
		public void valueChanged(TreeSelectionEvent e){
			
			TreePath path = e.getPath();
			Object[] pathNodes = path.getPath();
			String node = "";
			
			MonitorNode target = null;
			for (int i = 0; i < pathNodes.length; i++){
				DefaultMutableTreeNode n = (DefaultMutableTreeNode)pathNodes[i];
				MonitorNode nn = (MonitorNode)n.getUserObject();
				node += "." + nn.getId();
				target = nn;
			}
			
			Object[] paths = tree.getSelectionPaths();//shows what's currently selected
			if (paths == null){
				//nothing selected
				return;
			}
			
			selectedNodes.clear();
			for (int i = 0; i < paths.length; i++){
				Object[] elements = ((TreePath)paths[i]).getPath();
				String n = "";
				
				MonitorNode currentNode = null;
				for (int j = 0; j < elements.length; j++){
					DefaultMutableTreeNode t = (DefaultMutableTreeNode)elements[j];
					currentNode = (MonitorNode)t.getUserObject();
				}
				
				selectedNodes.add(currentNode);
			}
		
			
			//go over the list of nodes and handle their selection
			for (int i = 0; i < nodes.length; i++){
				Object nnn = nodes[i];
				DefaultMutableTreeNode tn = (DefaultMutableTreeNode)nodes[i];
				MonitorNode m = (MonitorNode)tn.getUserObject();
				if (selectedNodes.contains(m)){
					try{
						AnnotationComponent ac = m.getAnnotationComponent();
						if (ac == null) continue;
						
						ac.setSelected(true);
						m.selected = true;
						
						int type = ac.getType();
						if (type == AnnotationComponentRegistry.TYPE_HYDROGEN_BOND){
							MonitorRenderable r = (MonitorRenderable)hbonds.get(ac);
							r.setDirty();
						}
						else if (type == AnnotationComponentRegistry.TYPE_MONITOR){
							MonitorRenderable r = (MonitorRenderable)monitors.get(ac);
							r.setDirty();
						}
						else if (type == AnnotationComponentRegistry.TYPE_STERIC_BUMP){
							MonitorRenderable r = (MonitorRenderable)bumps.get(ac);
							r.setDirty();
						}
						else if (type == AnnotationComponentRegistry.TYPE_LABEL){
							MonitorRenderable r = (MonitorRenderable)labels.get(ac);
							r.setDirty();
						}
						else if (type == AnnotationComponentRegistry.TYPE_RESIDUE_LABEL){
							MonitorRenderable r = (MonitorRenderable)labels.get(ac);
							r.setDirty();
						}
					}
					catch (Exception ex){
//						System.out.println("e = " + ex);
					}
				}
				else{
					//deselect the node
					try{
						AnnotationComponent ac = m.getAnnotationComponent();
						if (ac == null) continue;
						ac.setSelected(false);
						m.selected = false;
						
						int type = ac.getType();
						if (type == AnnotationComponentRegistry.TYPE_HYDROGEN_BOND){
							MonitorRenderable r = (MonitorRenderable)hbonds.get(ac);
							r.setDirty();
						}
						else if (type == AnnotationComponentRegistry.TYPE_MONITOR){
							MonitorRenderable r = (MonitorRenderable)monitors.get(ac);
							r.setDirty();
						}
						else if (type == AnnotationComponentRegistry.TYPE_STERIC_BUMP){
							MonitorRenderable r = (MonitorRenderable)bumps.get(ac);
							r.setDirty();
						}
						else if (type == AnnotationComponentRegistry.TYPE_LABEL){
							MonitorRenderable r = (MonitorRenderable)labels.get(ac);
							r.setDirty();
						}
						else if (type == AnnotationComponentRegistry.TYPE_RESIDUE_LABEL){
							MonitorRenderable r = (MonitorRenderable)labels.get(ac);
							r.setDirty();
						}
					}
					catch (Exception ex){
//						System.out.println("e = " + ex);
					}
					
				}
			}
			
			callable.updateView();
			
			
		}
	}
	
	
	class IconCellRenderer extends DefaultTreeCellRenderer {
		
		protected Color textSelectioColor;
		protected Color textNonSelectionColor;
		protected Color bkSelectionColor;
		protected Color bkNonSelectionColor;
		protected Color borderSelectionColor;
		
		protected boolean selected;

		/**
		 * The renderer constructor.
		 */
		public IconCellRenderer() {
			
			super();
			
			textSelectionColor = UIManager.getColor("Tree.selectionForeground");
//			textSelectionColor = Color.black;
			textNonSelectionColor = UIManager.getColor("Tree.textForeground");
//			textNonSelectionColor = Color.red;
			bkSelectionColor = UIManager.getColor("Tree.selectionBackground");
//			bkSelectionColor = Color.red;
			bkNonSelectionColor = UIManager.getColor("Tree.textBackground");
//	/		bkNonSelectionColor = TreeViewer.bgColor;
			borderSelectionColor = UIManager.getColor("Tree.selectionBorderColor");
			setOpaque(false);
		}

		/**
		 * Returns the renderer based on the current situation in the tree representation.
		 */
		public Component getTreeCellRendererComponent(JTree tree,
			Object value, boolean sel, boolean expanded, boolean leaf,
			int row, boolean hasFocus) {

			// Invoke default implementation
			Component result = super.getTreeCellRendererComponent(tree,
				value, sel, expanded, leaf, row, hasFocus);

			DefaultMutableTreeNode node =
				(DefaultMutableTreeNode)value;
			Object obj = node.getUserObject();
			
			MonitorNode mn = (MonitorNode)obj;
			
			setText(mn.getName());
			
			if (obj instanceof MonitorNode) {
				MonitorNode idata = (MonitorNode)obj;
				setIcon(idata.getIcon());
			}
			else{
				setIcon(null);
			}
			
			Font font = new Font("Helvetica", Font.PLAIN, 12);
			setFont(font);
			setForeground(sel ? textSelectionColor : textNonSelectionColor);
			setBackground(sel ? bkSelectionColor : bkNonSelectionColor);
	
			setBackgroundNonSelectionColor(new Color(0.0f,0.0f,0.0f,0.0f));
	
			selected = sel;
			
			return result;
		}
		
	}

	private JMenuBar createMenuBar(){
		
		JMenuBar bar = new JMenuBar();
		
		JMenu options = new JMenu("Options");
		options.setMnemonic('o');
		JMenuItem actionColor = new JMenuItem("Couleur des tiquettes...");
		actionColor.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				Color color = JColorChooser.showDialog(callable.getApplicationFrame(), "Slectionner une nouvelle couleur d\'tiquette", Color.WHITE);
				if (color != null){
					setLabelColor(color);
				}
				else{
					callable.displayErrorMessage("La couleur n\'a pas t correctement lue. Ressayer");
				}
			}
		});
		
		JMenuItem actionText = new JMenuItem("Choisir le texte de l\'tiquette...");
		actionText.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				String input = (String)JOptionPane.showInputDialog(callable.getApplicationFrame(), 
						"Entrer un nouveau texte d\'tiquette", "Texte d\'tiquette", JOptionPane.INFORMATION_MESSAGE, null, null, null);
				setLabelText(input);
				
			}
		});
		
		final JMenu actionFont = new JMenu("Choisir la taille des caractres");
		final JMenuItem actionFontMedium = new JMenuItem("Moyenne");
		final JMenuItem actionFontSmall = new JMenuItem("Petite");
		final JMenuItem actionFontLarge = new JMenuItem("Grande");
		
		actionFontLarge.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				setFontSize(LabelGeometry.LARGE_FONT);
			}
		});
		
		actionFontMedium.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				setFontSize(LabelGeometry.MEDIUM_FONT);
			}
		});
		
		actionFontSmall.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				setFontSize(LabelGeometry.SMALL_FONT);
			}
		});
		
		
		actionFont.add(actionFontLarge);
		actionFont.add(actionFontMedium);
		actionFont.add(actionFontSmall);
		
		options.add(actionColor);
		options.add(actionText);
		options.add(new JSeparator());
		options.add(actionFont);
		
		JMenu data = new JMenu("Fichier");
		JMenuItem dataHB = new JMenuItem("Exporter les liaisons hydrogne...");
		dataHB.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				
				if (hbonds == null || hbonds.size() == 0) return;
				
				//get the desired file name
				JFileChooser chooser = new JFileChooser(callable.getLastUsedDirectory());
				chooser.setDialogTitle("Sauvegarder les donnes des liaisons hydrogne");

				chooser.setDialogType(JFileChooser.SAVE_DIALOG);

				chooser.addChoosableFileFilter( new FileNameFilter("txt", "Format texte dlimit par des espaces") );
				chooser.addChoosableFileFilter( new FileNameFilter("txt", "Format texte dlimit par des Tab") );
				chooser.addChoosableFileFilter( new FileNameFilter("csv", "Format CSV sparations par des virgules") );
				
				chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				int result = chooser.showSaveDialog(callable.getApplicationFrame());
				if (result == JFileChooser.CANCEL_OPTION){
					return;
				}
				
				File filename = chooser.getSelectedFile();
				
				callable.setLastUsedDirectory(filename.getParent());
				
				String fname = filename.toString();
				
				int dot = fname.lastIndexOf(".");

				//get the desired file type
				FileFilter filter = chooser.getFileFilter();
				
				if (dot <= 0){
					//no extension supplied
					fname += "." + filter.toString();
				}

				Vector components = new Vector();
				Set keys = hbonds.keySet();
				Iterator it = keys.iterator();
				while (it.hasNext()){
					components.add(it.next());
				}
				
				
				
				StringBuffer buffer = new StringBuffer();
				if (filter.getDescription().startsWith("Espace")){
					for (int i = 1; i <= components.size(); i++){
						buffer.append(new Integer(i).toString());
						buffer.append(" ");
						HydrogenBondComponent hc = (HydrogenBondComponent)components.get(i-1);
						Atom a1 = hc.atom1;
						Atom a2 = hc.atom2;
						
						buffer.append(a1.number);
						buffer.append(" ");
						buffer.append(a1.compound);
						buffer.append(a1.residue.getResidueId());
						buffer.append(":");
						buffer.append(a1.name);
						buffer.append(" ");
						
						buffer.append(a2.number);
						buffer.append(" ");
						buffer.append(a2.compound);
						buffer.append(a2.residue.getResidueId());
						buffer.append(":");
						buffer.append(a2.name);
						buffer.append(" ");
						
						
						double v = Algebra.distance(a1.coordinate, a2.coordinate);
						buffer.append(StringUtils.getFormattedNumber(v, 3));
						buffer.append("\n");
					}
				}
				else if (filter.getDescription().startsWith("Tab")){
					for (int i = 1; i <= components.size(); i++){
						buffer.append(new Integer(i).toString());
						buffer.append("\t");
						HydrogenBondComponent hc = (HydrogenBondComponent)components.get(i-1);
						Atom a1 = hc.atom1;
						Atom a2 = hc.atom2;
						
						buffer.append(a1.number);
						buffer.append("\t");
						buffer.append(a1.compound);
						buffer.append(a1.residue.getResidueId());
						buffer.append(":");
						buffer.append(a1.name);
						buffer.append("\t");
						
						buffer.append(new Integer(a2.number).toString());
						buffer.append("\t");
						buffer.append(a2.compound);
						buffer.append(a2.residue.getResidueId());
						buffer.append(":");
						buffer.append(a2.name);
						buffer.append("\t");
						
						
						double v = Algebra.distance(a1.coordinate, a2.coordinate);
						buffer.append(StringUtils.getFormattedNumber(v, 3));
						buffer.append("\n");
					}
				}
				else if (filter.getDescription().startsWith("Virgule")){
					for (int i = 1; i <= components.size(); i++){
						buffer.append(new Integer(i).toString());
						buffer.append(",");
						HydrogenBondComponent hc = (HydrogenBondComponent)components.get(i-1);
						Atom a1 = hc.atom1;
						Atom a2 = hc.atom2;
						
						buffer.append(a1.number);
						buffer.append(",");
						buffer.append(a1.compound);
						buffer.append(a1.residue.getResidueId());
						buffer.append(":");
						buffer.append(a1.name);
						buffer.append(",");
						
						buffer.append(a2.number);
						buffer.append(",");
						buffer.append(a2.compound);
						buffer.append(a2.residue.getResidueId());
						buffer.append(":");
						buffer.append(a2.name);
						buffer.append(",");
						
						double v = Algebra.distance(a1.coordinate, a2.coordinate);
						buffer.append(StringUtils.getFormattedNumber(v, 3));
						buffer.append("\n");
					}
				}
				else{
					callable.displayErrorMessage("Option de format de fichier illgale");
					return;
				}
				
				try{
					FileWriter fr = new FileWriter(fname);
					PrintWriter printer = new PrintWriter(fr);
					printer.print(buffer.toString());
					printer.close();
				}
				catch (Exception ex){
					ex.printStackTrace();
					
				}

			}
		});
		
		
		JMenuItem dataSC = new JMenuItem("Exporter les conflits striques");
		dataSC.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if (bumps == null || bumps.size() == 0) return;
				
				//get the desired file name
				JFileChooser chooser = new JFileChooser(callable.getLastUsedDirectory());
				chooser.setDialogTitle("Enregistrer les conflits striques");

				chooser.setDialogType(JFileChooser.SAVE_DIALOG);

				chooser.addChoosableFileFilter( new FileNameFilter("txt", "Format texte dlimit par des espaces") );
				chooser.addChoosableFileFilter( new FileNameFilter("txt", "Format texte dlimit par des Tab") );
				chooser.addChoosableFileFilter( new FileNameFilter("csv", "Format CSV sparations par des virgules") );
				
				chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				int result = chooser.showSaveDialog(callable.getApplicationFrame());
				if (result == JFileChooser.CANCEL_OPTION){
					return;
				}
				
				File filename = chooser.getSelectedFile();
				
				callable.setLastUsedDirectory(filename.getParent());
				
				String fname = filename.toString();
				
				int dot = fname.lastIndexOf(".");

				//get the desired file type
				FileFilter filter = chooser.getFileFilter();
				
				if (dot <= 0){
					//no extension supplied
					fname += "." + filter.toString();
				}

				Vector components = new Vector();
				Set keys = bumps.keySet();
				Iterator it = keys.iterator();
				while (it.hasNext()){
					components.add(it.next());
				}
				
				
				
				StringBuffer buffer = new StringBuffer();
				if (filter.getDescription().startsWith("Espace")){
					for (int i = 1; i <= components.size(); i++){
						buffer.append(new Integer(i).toString());
						buffer.append(" ");
						StericBumpComponent sc = (StericBumpComponent)components.get(i-1);
						Atom a1 = sc.atom1;
						Atom a2 = sc.atom2;
						
						buffer.append(a1.number);
						buffer.append(" ");
						buffer.append(a1.compound);
						buffer.append(a1.residue.getResidueId());
						buffer.append(":");
						buffer.append(a1.name);
						buffer.append(" ");
						
						buffer.append(a2.number);
						buffer.append(" ");
						buffer.append(a2.compound);
						buffer.append(a2.residue.getResidueId());
						buffer.append(":");
						buffer.append(a2.name);
						buffer.append(" ");
						
						
						double v = Algebra.distance(a1.coordinate, a2.coordinate);
						buffer.append(StringUtils.getFormattedNumber(v, 3));
						buffer.append("\n");
					}
				}
				else if (filter.getDescription().startsWith("Tab")){
					for (int i = 1; i <= components.size(); i++){
						buffer.append(new Integer(i).toString());
						buffer.append("\t");
						StericBumpComponent hc = (StericBumpComponent)components.get(i-1);
						Atom a1 = hc.atom1;
						Atom a2 = hc.atom2;
						
						buffer.append(a1.number);
						buffer.append("\t");
						buffer.append(a1.compound);
						buffer.append(a1.residue.getResidueId());
						buffer.append(":");
						buffer.append(a1.name);
						buffer.append("\t");
						
						buffer.append(new Integer(a2.number).toString());
						buffer.append("\t");
						buffer.append(a2.compound);
						buffer.append(a2.residue.getResidueId());
						buffer.append(":");
						buffer.append(a2.name);
						buffer.append("\t");
						
						
						double v = Algebra.distance(a1.coordinate, a2.coordinate);
						buffer.append(StringUtils.getFormattedNumber(v, 3));
						buffer.append("\n");
					}
				}
				else if (filter.getDescription().startsWith("Virgule")){
					for (int i = 1; i <= components.size(); i++){
						buffer.append(new Integer(i).toString());
						buffer.append(",");
						StericBumpComponent hc = (StericBumpComponent)components.get(i-1);
						Atom a1 = hc.atom1;
						Atom a2 = hc.atom2;
						
						buffer.append(a1.number);
						buffer.append(",");
						buffer.append(a1.compound);
						buffer.append(a1.residue.getResidueId());
						buffer.append(":");
						buffer.append(a1.name);
						buffer.append(",");
						
						buffer.append(a2.number);
						buffer.append(",");
						buffer.append(a2.compound);
						buffer.append(a2.residue.getResidueId());
						buffer.append(":");
						buffer.append(a2.name);
						buffer.append(",");
						
						double v = Algebra.distance(a1.coordinate, a2.coordinate);
						buffer.append(StringUtils.getFormattedNumber(v, 3));
						buffer.append("\n");
					}
				}
				else{
					callable.displayErrorMessage("Option de format de fichier illgale");
					return;
				}
				
				try{
					FileWriter fr = new FileWriter(fname);
					PrintWriter printer = new PrintWriter(fr);
					printer.print(buffer.toString());
					printer.close();
				}
				catch (Exception ex){
					ex.printStackTrace();
					
				}
			}
		});
		
		data.add(dataHB);
		data.add(dataSC);
		
		bar.add(data);
		bar.add(options);
		
		
		return bar;
	}
	
	private void setFontSize(int size){
		
		//get the currently selected nodes
		Object[] paths = tree.getSelectionPaths();//shows what's currently selected
		if (paths == null){
			//nothing selected
			return;
		}
		else{
			Vector selectedNodes = new Vector();
			for (int i = 0; i < paths.length; i++){
				Object[] elements = ((TreePath)paths[i]).getPath();
				String n = "";
				
				MonitorNode currentNode = null;
				for (int j = 0; j < elements.length; j++){
					DefaultMutableTreeNode t = (DefaultMutableTreeNode)elements[j];
					currentNode = (MonitorNode)t.getUserObject();
				}
				
				selectedNodes.add(currentNode);
			}
			
			for (int i = 0; i < selectedNodes.size(); i++){
				MonitorNode node = (MonitorNode)selectedNodes.get(i);
				
				AnnotationComponent component = (AnnotationComponent)node.getAnnotationComponent();
				if (component == null) continue;
				
				if (component.getType() == AnnotationComponentRegistry.TYPE_LABEL){
					((LabelComponent)component).setFont(size);
					((GlRenderable)labels.get(component)).setDirty();
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_RESIDUE_LABEL){
					((ResidueLabelComponent)component).setFont(size);
					((GlRenderable)labels.get(component)).setDirty();
				}
	
			}
		}
		
		structureViewer.getGeometryViewer().updateView();
	}
	
	private void setLabelText(String text){
		
		//get the currently selected nodes
		Object[] paths = tree.getSelectionPaths();//shows what's currently selected
		if (paths == null){
			//nothing selected
			return;
		}
		else{
			Vector selectedNodes = new Vector();
			for (int i = 0; i < paths.length; i++){
				Object[] elements = ((TreePath)paths[i]).getPath();
				String n = "";
				
				MonitorNode currentNode = null;
				for (int j = 0; j < elements.length; j++){
					DefaultMutableTreeNode t = (DefaultMutableTreeNode)elements[j];
					currentNode = (MonitorNode)t.getUserObject();
				}
				
				selectedNodes.add(currentNode);
			}
			
			for (int i = 0; i < selectedNodes.size(); i++){
				MonitorNode node = (MonitorNode)selectedNodes.get(i);
				
				AnnotationComponent component = (AnnotationComponent)node.getAnnotationComponent();
				if (component == null) continue;
				
				if (component.getType() == AnnotationComponentRegistry.TYPE_LABEL){
					((LabelComponent)component).label = text;
					((LabelComponent)component).dataType = LabelDialog.TYPE_CUSTOM;
					component.setSelected(false);
					((GlRenderable)labels.get(component)).setDirty();
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_RESIDUE_LABEL){
					((ResidueLabelComponent)component).label = text;
					((ResidueLabelComponent)component).dataType = LabelDialog.TYPE_CUSTOM;
					component.setSelected(false);
					((GlRenderable)labels.get(component)).setDirty();
				}
	
			}
		}
		
		updateTree();
		structureViewer.getGeometryViewer().updateView();
	}
	
	private void setLabelColor(Color color){
		
		//get the currently selected nodes
		Object[] paths = tree.getSelectionPaths();//shows what's currently selected
		if (paths == null){
			//nothing selected
			return;
		}
		else{
			Vector selectedNodes = new Vector();
			for (int i = 0; i < paths.length; i++){
				Object[] elements = ((TreePath)paths[i]).getPath();
				String n = "";
				
				MonitorNode currentNode = null;
				for (int j = 0; j < elements.length; j++){
					DefaultMutableTreeNode t = (DefaultMutableTreeNode)elements[j];
					currentNode = (MonitorNode)t.getUserObject();
				}
				
				selectedNodes.add(currentNode);
			}
			
			for (int i = 0; i < selectedNodes.size(); i++){
				MonitorNode node = (MonitorNode)selectedNodes.get(i);
				
				AnnotationComponent component = (AnnotationComponent)node.getAnnotationComponent();
				if (component == null) continue;
				
				if (component.getType() == AnnotationComponentRegistry.TYPE_LABEL){
					((LabelComponent)component).color = new float[]{ ((float)color.getRed())/255.0f, ((float)color.getGreen())/255.0f, 
							((float)color.getBlue())/255.0f };
					((GlRenderable)labels.get(component)).setDirty();
				}
				else if (component.getType() == AnnotationComponentRegistry.TYPE_RESIDUE_LABEL){
					((ResidueLabelComponent)component).color = new float[]{ ((float)color.getRed())/255.0f, ((float)color.getGreen())/255.0f, 
							((float)color.getBlue())/255.0f };
					((GlRenderable)labels.get(component)).setDirty();
				}
	
			}
		}
		
		//deselect to reflect color change
		clearSelection();

		structureViewer.getGeometryViewer().updateView();
	}


}
