package edu.sdsc.sirius.builder;

import java.awt.*;

import javax.swing.*;
import edu.sdsc.sirius.util.Manager;

import javax.swing.border.*;
import java.util.*;

public class ProteinFragmentPanel extends JPanel implements FragmentGroupPanel {
	
	private final String NAME = "Editeur de peptide";
	private Manager parent;
	private BuilderPanel builderPanel;
	
	private Vector buttons = new Vector();
	private JPanel main = new JPanel();
	
//	private Vector numbers = new Vector();//ids that belong in this panel
	
	
	public ProteinFragmentPanel(){
				
		setBorder(new EmptyBorder(5,5,5,5));
		setLayout(new BorderLayout());
		
		main.setLayout(new GridLayout(5,4));
		main.setPreferredSize(new Dimension(270, 320));
		
		
		for (int i = 20; i < 40; i++){
			FragmentButton button = new FragmentButton((FragmentRecord)FragmentRegistry.getFragmentRecords().get(i), this );
			main.add(button);
			buttons.add(button);
		}
		
		add(main, BorderLayout.NORTH);
		
		//add Rama plot panel
		JPanel rpanel = new JPanel();
		rpanel.setPreferredSize(new Dimension(270, 50));
		
	}
	
	public String getFragmentGroupName(){
		return NAME;
	}
	
	public void setParentApplication(Manager c){
		parent = c;
	}
	
	public Manager getParentApplication(){
		return parent;
	}
	
	public void processButtonClick(String id){
		//process click appearance
		for (int i = 0; i < buttons.size(); i++){
			FragmentButton b = (FragmentButton)buttons.get(i);
			if (b.number != id) b.setPressed(false);
		}
		
		builderPanel.deselectButtons(this);

		FragmentRegistry.activeFragment = id;
		
	}
	
	public void setBuilderPanel(BuilderPanel builderPanel){
		this.builderPanel = builderPanel;
	}
	
	public void deselectButtons(){
		for (int i = 0; i < buttons.size(); i++){
			FragmentButton b = (FragmentButton)buttons.get(i);
			b.setPressed(false);
		}
		
	}
	
	public void updatePanel(){}


}
