package edu.sdsc.sirius.search;

import javax.swing.*;
import java.util.*;
import edu.sdsc.sirius.util.Manager;

import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.event.*;

public class DataAccessPanel extends JDialog {
	
	private Manager parent;
	private JTabbedPane basePane;
	private JFrame frame;
	
	private int width = 400;
	private int height = 600;
	
	private DataAccessPanel thisObject;
	
	/**
	 * ArrayList of ServicePanels
	 */
	private ArrayList panels;
	
	
	public DataAccessPanel(JFrame frame, Manager parent){
		
		super(frame, "Panneau d\'accs aux donnes", false);
		this.parent = parent;
		this.frame = frame;
		
		thisObject = this;
		
		getContentPane().setLayout(new BorderLayout());
		
		basePane = new JTabbedPane();
		basePane.addChangeListener(new CustomChangeListener());
			
		panels = SearchServicesRegistry.getServicePanels();
		
		for (int i = 0; i < panels.size(); i++){
			SearchServicePanel sp = (SearchServicePanel)panels.get(i);
			sp.setParentApplication(parent);
			basePane.addTab(sp.getSearchServiceName(), (JPanel)sp);
		}

		getContentPane().add(basePane, BorderLayout.CENTER);
		
		WindowAdapter closer = new WindowAdapter(){
			public void windowClosing( WindowEvent event ){
				setVisible(false);
				thisObject.parent.closeDataAccessPanel();
			}
		};
		addWindowListener( closer );
		
		//position the window
		Dimension dim = getToolkit().getScreenSize();
		
		//position the panel next to the main window on the right
		//if it ends up being wider than screen, fit it to the width of the screen
		if ((frame.getX() + frame.getWidth() + width) > dim.getWidth()){
			setBounds(dim.width - width, frame.getY(), width, height);
		}
		else{
			setBounds(frame.getX() + frame.getWidth(), frame.getY(), width, height);
		}
		setSize(width, height);

		setVisible(true);
	}
	
	public SearchServicePanel getSearchServicePanel(String name){
		for (int i = 0; i < panels.size(); i++){
			SearchServicePanel sp = (SearchServicePanel)panels.get(i);
			if (sp.getSearchServiceName().equals(name)){
				return sp;
			}
		}
		return null;
	}
	
	public SearchServicePanel getSearchServicePanel(int index){
		return (SearchServicePanel)panels.get(index);
	}

	class CustomChangeListener implements ChangeListener {
		public void stateChanged(ChangeEvent e){
			int index = ((JTabbedPane)e.getSource()).getSelectedIndex();
			parent.setActiveSearchServicePanel(getSearchServicePanel(index));
			((SearchServicePanel)((JTabbedPane)e.getSource()).getSelectedComponent()).setFocus();
		}
	}
	
}
